/* 
 *    Achtung Tabs stehen auf 4
 *  fuer vi:    set ts=4 sw=4 eingeben
 *
 *  Testprogramm fuer Terminalserver
 *
 *  +----+   Netz     +------+ 
 *  | TS |------------| UNIX |
 *  +----+            +------+
 *    | RS 232
 *  +----+
 *  |    | Schnittstellentester im Echo Mode ( oder aehnliches Geraet )
 *  +----+
 *
 *  Es werden die Zeichen 0x00 - 0xff auf stdout ausgegeben. stdout wird
 *  ueber das Programm sockif auf Port 7002 des Terminalservers umgelenkt.
 *  Die Zeichen die am TS auf Port A ausgegeben werden, werden durch den
 *  Schnittstellentester wieder eingegeben. Der TS uebertraegt die Zeichen
 *  zum Programm sockif, dieses uebergibt sie an stdin. Ist das empfangene
 *  Zeichen ungleich dem gesendeten, wird eine Fehlermeldung in die Datei
 *  test.err ausgegeben. (stderr wird durch sockif ebenfalls umgeleitet !!!)
 *
 *  Aufruf fuer RS 232 Port A:
 *  DNIX:   sockif.dnix -e tstest.dnix IP-Nummer 7002
 *  SCO:    sockif.sco  -e tstest.sco  IP-Nummer 7002
 *
 */

#include <stdio.h>

int             main(int argc, char **argv)
{
	FILE           *fp;
	int             i;

/* keine Fehlerabfrage, da stderr schon auf Socket umgeleitet ist */
	fp = fopen("test.err", "w");

/* kein 'buffered I/O' verwenden, damit jedes Zeichen sofort rausgeht */
	setbuf(stdin, NULL);
	setbuf(stdout, NULL);

/* Zeichen von 0x00 bis 0xff ausgeben und echo ueberpruefen */
	for (i = 0; i < 256; i++)
	{
		putchar(i);
		if (getchar() != i)
			fprintf(fp, "Fehler fuer %d\n", i);
	}
	fclose(fp);
}
